React UI Components Documentation

ReactJS DataTable Component

The DataTable component for ReactJS represents a lightweight Table widget built to easily replace your HTML Tables.

Prerequisites

Refer to ReactJS Getting Started before you start with this help topic.

Configuration

The DataTable component for ReactJS requires the following imports.

 
import React from 'react';
import ReactDOM from 'react-dom';
import JqxDataTable from 'jqwidgets-react/react_jqxdatatable.js';

Then we create our component class. Properties and methods are put as ReactJS props.

  
class App extends React.Component {
render () {
return (
<JqxDataTable
source={dataAdapter} sortable={true}
pageable={true} columns={columns}
/>
)
}
}

Finally we render our class in the desired HTML element:

 
ReactDOM.render(<App />, document.getElementById('app'));

Events Methods & Properties

In order to bind to any event, change any property or call any method, we need a reference to the component.
For that we use the ReactJS "ref" Callback Attribute:

 
<JqxDataTable ref='myDataTable' source={dataAdapter} columns={columns}..... />

Now, when we have a reference, we need to call the desired event/property/method.
This is done in the componentDidMount() ReactJS Component Lifecycle method.

 
class App extends React.Component {
componentDidMount()
{
//your logic
}
render ()
{
return
(
....
)
}
};

Events

The sort event is triggered when the DataTable sort order or sort column is changed.

The following example demonstrates how to add an event listener:

Methods & Properties

This is how you call methods & props:

Every component have a method setOptions which accepts a object as an argument. This object contains component settings.

Every component also have a method getOptions which returns a object containing the component settings.

DataTable Examples

Overview

The following example demonstrates how to create a DataTable component.

Editing

The following example demonstrates how to create an editable DataTable component.

DataTable API

API Reference of the jQWidgets DataTable component for React: DataTable API

Vue UI Components Documentation

Vue DataTable Component

The DataTable component for Vue represents a lightweight Table widget built to easily replace your HTML Tables.

Prerequisites

Refer to Vue Getting Started before you start with this help topic.

Configuration

After you have created your App.vue file, here is how you should structure it:

The DataTable component for Vue requires the following import:

import JqxDataTable from "jqwidgets-scripts/jqwidgets-vue/vue_jqxdatatable.vue";

Add the jqxDataTable component to the components section of the the Vue class:

 components: {
JqxDataTable
},

Template

The App.vue has a <template> structural tag where we determine the application structure. There we will also set the tags for the new components - <JqxDataTable/>

<template>
<JqxDataTable :width="width" :source="dataAdapter" :columns="columns"
:altRows="true" :pageable="true" :filterable="true">
</JqxDataTable>
</template>

Properties

The properties of the <JqxDataTable/> component are defined in the data member of the Vue class. We should put them in the return object of the data function:

data: function () {
return {
width: 500,
dataAdapter: new jqx.dataAdapter(this.source),
columns: [
{ text: 'Supplier Name', cellsAlign: 'center', align: 'center', dataField: 'SupplierName', width: 250 },
{ text: 'Name', cellsAlign: 'center', align: 'center', dataField: 'ProductName', width: 250 },
{ text: 'Quantity', dataField: 'Quantity', cellsFormat: 'd', cellsAlign: 'center', align: 'center', width: 120 },
{ text: 'Price', dataField: 'Price', cellsFormat: 'c2', align: 'center', cellsAlign: 'center', width: 120 },
{ text: 'City', cellsAlign: 'center', align: 'center', dataField: 'City' }
]
}
}

Events

The events in Vue are set as an attribute with @ prefix, for example:

<JqxDataTable @filter="onFilter()" :width="width" :source="dataAdapter" 
:columns="columns":altRows="true" :pageable="true" :filterable="true">
</JqxDataTable>

All events that are bound to a component are implemented in the methods member of the Vue class.

methods: {
onFilter: function () {
// Do something...
}
}

Methods

To use a component's method we should have its reference. In Vue we refer to a component by the special $refs property. Before that we need to add the desired name reference to that component:

<JqxDataTable ref="datatable"></JqxDataTable>

Here how you can use a component's method:

this.$refs.datatable.refresh();

methods: {
// Add here all used callbacks and/or events
onFilter: function () {
// Do something on filter
this.$refs.datatable.refresh();
}
}

If we want to add additional methods we should also implement them in the methods member.

In case we need to do some precalculation or something else before the components are rendered, we should use the beforeCreate member. In this case:

beforeCreate: function () {
// Add here any data where you want to transform before components be rendered
this.source = {
dataType: 'xml',
dataFields: [
{ name: 'SupplierName', type: 'string' },
{ name: 'Quantity', type: 'number' },
{ name: 'OrderDate', type: 'date' },
{ name: 'OrderAddress', type: 'string' },
{ name: 'Freight', type: 'number' },
{ name: 'Price', type: 'number' },
{ name: 'City', type: 'string' },
{ name: 'ProductName', type: 'string' },
{ name: 'Address', type: 'string' }
],
url: 'sampledata/orderdetailsextended.xml',
root: 'DATA',
record: 'ROW'
};
}

If you have followed the above steps, you App.vue file would look like this:

App.vue:

DataTable Example

Run Code

Angular UI Components Documentation

Angular DataTable Component

The DataTable component for Angular represents a lightweight Table widget built to easily replace your HTML Tables.

1. Installation

The easiest way to get started with jQWidgets UI for Angular is to use the Angular CLI Tool. To scaffold your project structure, follow its installation instructions.

npm install -g @angular/cli
ng new jqwidgets-project
cd jqwidgets-project

Install jQWidgets

jQWidgets Angular UI comes packaged with Angular CLI schematics to make creating Angular applications easier. Schematics are included with both @angular/cdk and jqwidgets-ng. Once you install the npm packages, they will be available through the Angular CLI.

Angular CLI supports the addition of packages through the ng add command. The ng add command provides faster and more user-friendly package installation. To install the jQWidgets UI for Angular package, use ng add and add the name of the NPM package:

ng add jqwidgets-ng

Alternatively, you can use the standard installation (Manual Setup)

jQWidgets UI for Angular is distributed as jqwidgets-ng NPM package

  1. Download and install the package.
    npm install jqwidgets-ng
  2. Adding CSS reference

    The following CSS file is available in ../node_modules/jqwidgets-ng/ package folder. This can be referenced in [src/styles.css] using following code.

    @import 'jqwidgets-ng/jqwidgets/styles/jqx.base.css';

    Another way to achieve the same is to edit the angular.json file and in the styles add the style.

    "styles": [
    	"node_modules/jqwidgets-ng/jqwidgets/styles/jqx.base.css"
    ]
    

2. Add the HTML for jQWidgets component in src/app/app.component.html

app.component.html


<jqxDataTable [theme]="'fluent'"
    [width]="getWidth()" [columns]="columns" [selectionMode]="'singleRow'"
    [altRows]="true" [sortable]="true" [editable]="true">
      <table id='table' border='1'>
        <thead>
          <tr>
            <th align='left'>First Name</th>
            <th align='left'>Last Name</th>
            <th align='left'>Product</th>
            <th align='right'>Price</th>
            <th align='right'>Quantity</th>
          </tr>
        </thead>
        <tbody>
          <tr>
            <td>Ian</td>
            <td>Devling</td>
            <td>Espresso Truffle</td>
            <td>$1.75</td>
            <td>8</td>
          </tr>
          <tr>
            <td>Nancy</td>
            <td>Wilson</td>
            <td>Cappuccino</td>
            <td>$5.00</td>
            <td>3</td>
          </tr>
          <tr>
            <td>Cheryl</td>
            <td>Nodier</td>
            <td>Caffe Americano</td>
            <td>$2.50</td>
            <td>4</td>
          </tr>
          <tr>
            <td>Martin</td>
            <td>Saavedra</td>
            <td>Caramel Latte</td>
            <td>$3.80</td>
            <td>11</td>
          </tr>
          <tr>
            <td>Guylene</td>
            <td>Bjorn</td>
            <td>Green Tea</td>
            <td>$1.50</td>
            <td>8</td>
          </tr>
          <tr>
            <td>Andrew</td>
            <td>Burke</td>
            <td>Caffe Espresso</td>
            <td>$3.00</td>
            <td>2</td>
          </tr>
          <tr>
            <td>Regina</td>
            <td>Murphy</td>
            <td>White Chocolate Mocha</td>
            <td>$3.60</td>
            <td>6</td>
          </tr>
          <tr>
            <td>Michael</td>
            <td>Murphy</td>
            <td>Caramel Latte</td>
            <td>$3.80</td>
            <td>2</td>
          </tr>
          <tr>
            <td>Petra</td>
            <td>Bein</td>
            <td>Caffe Americano</td>
            <td>$2.50</td>
            <td>7</td>
          </tr>
          <tr>
            <td>Nancy</td>
            <td>Nodier</td>
            <td>Caffe Latte</td>
            <td>$4.50</td>
            <td>10</td>
          </tr>
          <tr>
            <td>Peter</td>
            <td>Devling</td>
            <td>Green Tea</td>
            <td>$1.50</td>
            <td>1</td>
          </tr>
          <tr>
            <td>Beate</td>
            <td>Saylor</td>
            <td>Espresso con Panna</td>
            <td>$3.25</td>
            <td>3</td>
          </tr>
          <tr>
            <td>Shelley</td>
            <td>Nodier</td>
            <td>Peppermint Mocha Twist</td>
            <td>$4.00</td>
            <td>7</td>
          </tr>
          <tr>
            <td>Nancy</td>
            <td>Murphy</td>
            <td>Peppermint Mocha Twist</td>
            <td>$4.00</td>
            <td>1</td>
          </tr>
          <tr>
            <td>Lars</td>
            <td>Wilson</td>
            <td>Caffe Espresso</td>
            <td>$3.00</td>
            <td>11</td>
          </tr>
        </tbody>
      </table>
</jqxDataTable>

	

3. Setup Component Logic

app.component.ts


import { Component } from '@angular/core';

import { jqxDataTableModule, jqxDataTableComponent } from 'jqwidgets-ng/jqxdatatable';
@Component({
    selector: 'app-root',
    imports: [jqxDataTableModule],
    standalone: true,
    templateUrl: './app.component.html'
})

export class AppComponent {

    getWidth(): any {
        if (document.body.offsetWidth < 850) {
            return '90%';
        }

        return 850;
    }

    columns: any[] =
        [
            { text: 'First Name', dataField: 'First Name', width: 200 },
            { text: 'Last Name', dataField: 'Last Name', width: 200 },
            { text: 'Product', dataField: 'Product', width: 250 },
            { text: 'Unit Price', dataField: 'Price', width: 100, align: 'right', cellsAlign: 'right', cellsFormat: 'c2' },
            { text: 'Quantity', dataField: 'Quantity', width: 100, align: 'right', cellsAlign: 'right', cellsFormat: 'n' }
        ];
}

Summary

jQWidgets UI for Angular provides an easy way to integrate robust UI components into your Angular project. By using either the ng add command or manual setup, you can quickly get started. Once the setup is complete, you can add the desired jQWidgets components and configure them in your Angular components to match your application requirements.

DataTable API

API Reference of the jQWidgets DataTable component for Angular: DataTable API